#ifndef	__OPENCASL_H
#define	__OPENCASL_H

#include <stdio.h>

/*
**	OPENCASL.H
*/
#ifndef	TRUE
#define	TRUE	1
#endif

#ifndef	FALSE
#define	FALSE	0
#endif

#ifndef	NUL
#define	NUL		'\0'
#endif

#define	ERROR	(-1)
#define	NOERROR	0

#define	MAXNAME		32
#define	MAXLABEL	128
#define	MAXITEMS	16
#define	ORGADDR		0x0010

#define	CMD_NOP		0x0000
#define	CMD_LD		0x0100
#define	CMD_ST		0x0200
#define	CMD_LAD		0x0300
#define	CMD_ADDA	0x0400
#define	CMD_ADDL	0x0500
#define	CMD_SUBA	0x0600
#define	CMD_SUBL	0x0700
#define	CMD_AND		0x0800
#define	CMD_OR		0x0900
#define	CMD_XOR		0x0a00
#define	CMD_CPA		0x0b00
#define	CMD_CPL		0x0c00
#define	CMD_SLA		0x0d00
#define	CMD_SRA		0x0e00
#define	CMD_SLL		0x0f00
#define	CMD_SRL		0x1000
#define	CMD_JPL		0x1100
#define	CMD_JMI		0x1200
#define	CMD_JNZ		0x1300
#define	CMD_JZE		0x1400
#define	CMD_JOV		0x1500
#define	CMD_JUMP	0x1600
#define	CMD_PUSH	0x1700
#define	CMD_POP		0x1800
#define	CMD_CALL	0x1900
#define	CMD_RET		0x1a00
#define	CMD_INPUT	0x1b00
#define	CMD_OUTPUT	0x1c00
#define	CMD_RPUSH	0x1d00
#define	CMD_RPOP	0x1e00
#define	CMD_SVC		0x1f00
#define	CMD_IN		0x2000
#define	CMD_OUT		0x2100
#define	CMD_EXIT	0x2200
#define	CMD_START	0x2300
#define	CMD_END		0x2400
#define	CMD_DS		0x2500
#define	CMD_DC		0x2600

#define	GR0			0x0000
#define	GR1			0x0010
#define	GR2			0x0020
#define	GR3			0x0030
#define	GR4			0x0040
#define	GR5			0x0050
#define	GR6			0x0060
#define	GR7			0x0070

#define	GR20		0x0080
#define	GR21		0x0090
#define	GR22		0x00a0
#define	GR23		0x00b0
#define	GR24		0x00c0
#define	GR25		0x00d0
#define	GR26		0x00e0
#define	GR27		0x00f0

#define	XR1			0x0001
#define	XR2			0x0002
#define	XR3			0x0003
#define	XR4			0x0004
#define	XR5			0x0005
#define	XR6			0x0006
#define	XR7			0x0007

typedef	unsigned char	byte;
typedef	unsigned short	word;

typedef	struct	tag_mnemonic {
	word	opeCode;
	int		opeType;
	int		opeSize;
	char	key[MAXNAME];
} MNEMONIC;

typedef	struct	tag_label {
	char	name[MAXNAME];
	word	address;
} LABEL;

typedef	struct	tag_exabel {
	char	name[MAXNAME];
	char	alias[MAXNAME];
	word	address;
	word	value;
} EXLABEL;

void assemble(char* fname);
int pass1(char *fname);
int pass2(char *fname);
word getDCSize(char **items, int pos, int size);
void dispHelp();

word executeLineAssemble(word address);

word getAddress(char *s);
word execAsm0(word address, int op, char *items[], int p);
word execAsm1(word address, int op, char *items[], int p);
word execAsm2(word address, int op, char *items[], int p);
word execAsm3(word address, int op, char *items[], int p);
word execAsm4(word address, int op, char *items[], int p);
word execAsm5(word address, int op, char *items[], int p);
word execAsm6(word address, int op, char *items[], int p);
word execAsm7(word address, int op, char *items[], int p);
word execAsm8(word address, int op, char *items[], int p);
word execAsm9(word address, int op, char *items[], int p);

int initLable();
LABEL *newLable(char *name, word address);
EXLABEL *newExLabel(char *name, word address, word value);
void clearLabels();
void deleteLabel();
int searchLabel(char* name);
int searchExLabel(char *name);
int addLabel(char *name, word address);
int addExLabel(char *name);
int setLabelAddress(char *name, word address);
int setExLabelAddress(char *name, word address);
int setExLabelValue(char *name, word value);
word getLabelAddress(char *name);
word getExLabelAddress(char *name);
word getExLabelValue(char *name);
word alignExLabels(word address);
word getExLabelsNameValue(char *s);
void printLabels();
void printExLabelsPrn(FILE *prn, word address);
void outExLabelsObj();

int isMnemonic(char *name);
word getOpeCode(int pos);
int getOpeType(int pos);
int getOpeSize(int pos);

char *skipSpace(char *s);
int dividString(char *items[], char *s);

void makeObjName(char *s, char *d);
void makePrnName(char *s, char *d);
void makeSymName(char *s, char *d);
void changeExt(char *s, char *d, char *e);
word getWord(char *s);
int isGR(char *s);
int isXR(char *s);
word htow(char *s);
int isAllDigit(char *s);
int isAllXDigit(char *s);
void printItems(char *items[]);

#endif
