/*
**	paser.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "opencasl.h"


/*	execute assemble	*/
extern	char	inbuf[BUFSIZ];
extern	FILE	*obj, *prn;
extern	int		lineNo;
extern	char	errorMsg[BUFSIZ];
extern	int		errorFlag, nError;

extern	void displayError(char *msg);

word executeLineAssemble(word address)
{
	int		n, p, op, type;
	char	*items[MAXITEMS];
	
	errorFlag = FALSE;
	n = dividString(items, inbuf);
	if (0 < n) {
		if ((op = isMnemonic(items[p = 0])) < 0) {
			if (!isalpha(*items[p])) {
				errorFlag = TRUE;
				sprintf(errorMsg, "%3d行目 ラベル名が英文字以外で始まっています", lineNo);
				displayError(errorMsg);
			}
			p++;
			if (p < n) {
				op = isMnemonic(items[p]);
			} else {
				return address;
			}
		}
		if (op < 0) {
			errorFlag = TRUE;
			sprintf(errorMsg, "%3d行目 命令コードがないか、書き間違えをしています", lineNo);
			displayError(errorMsg);
		} else {
			type = getOpeType(op);
			switch (type) {
			case 0:
				address = execAsm0(address, op, items, p);
				break;
			case 1:
				address = execAsm1(address, op, items, p);
				break;
			case 2:
				address = execAsm2(address, op, items, p);
				break;
			case 3:
				address = execAsm3(address, op, items, p);
				break;
			case 4:
				address = execAsm4(address, op, items, p);
				break;
			case 5:
				address = execAsm5(address, op, items, p);
				break;
			case 6:
				address = execAsm6(address, op, items, p);
				break;
			case 7:
				address = execAsm7(address, op, items, p);
				break;
			case 8:
				address = execAsm8(address, op, items, p);
				break;
			case 9:
				address = execAsm9(address, op, items, p);
				break;
			default:
				break;
			}
		}
	} else {
		fprintf(prn, "%04X:          \t%s", address, inbuf);
	}
	return address;
}
