/*
**	oce.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "opencomet.h"

int main(int argc, char *argv[])
{
	int		i;
	int		result = 0;
	char	*p;

	/*	main loop */
	for (i = 1; i < argc; i++) {
		p = argv[i];
		if (*p == '-') {
			p++;
			switch(*p) {
			case 'h':
				dispHelp();
				exit(0);
			default:
				break;
			}
		} else {
			oce(argv[i]);
			break;
		}
	}
	
	return result;
}

void oce(char *fname)
{
	int		n;

	n = loadObject(fname);
	printf("%s: %d ワードのオブジェクトを読み込みました\n", fname, n);
	n = loadSymbol(fname);
	printf("%s: %d 個のシンボルを読み込みました\n", fname, n);
	printf("デバッグを開始できます\n\n");
	
	executeDebug();
	
	deleteMemory();
	deleteLabel();
}

void executeDebug()
{

	int		eFlag, sFlag;
	int		command;
	int		n;
	char	cmd[BUFSIZ];
	char	lastcmd[BUFSIZ];
	char	*items[MAXITEMS];
	
	eFlag = FALSE;
	sFlag = FALSE;
	*lastcmd = NUL;
	while (!eFlag) {
		if (!sFlag) {
			printCPU();
			linePrint();
		} else {
			sFlag = FALSE;
		}
		printf("COMMAND> ");
		fgets(cmd, BUFSIZ, stdin);
		removeEOL(cmd);
		if (*cmd == NUL) {
			strcpy(cmd, lastcmd);
		}
		upperCase(cmd);
		if (0 < (n = getCommandLine(items, cmd))) {
			command = toupper(*items[0]);
			switch (command) {
			case 'D':
				executeDump(n, items);
				sFlag = TRUE;
				break;
			case 'L':
				executeList(n, items);
				sFlag = TRUE;
				break;
			case 'S':
				executeStep(n, items);
				break;
			case 'R':
				executeSetRegister(n, items);
				break;
			case 'G':
				executeRun(n, items);
				break;
			case 'B':
				executeSetBP(n, items);
				sFlag = TRUE;
				break;
			case 'C':
				executeClearBP(n, items);
				sFlag = TRUE;
				break;
			case 'Q':
				eFlag = TRUE;
				break;
			}
		}
		strcpy(lastcmd, cmd);
	}
}

int loadObject(char *fname)
{
	word	pos = 0x10;
	word	data;
	FILE	*rp;
	char	filename[BUFSIZ];

	initMemory();
	clearMemory();
	clearBreakPoint();
	initEnvironment();
	makeObjName(fname, filename);
	if ((rp = fopen(filename, "r")) == NULL) {
		return 0;
	}
	while (0 < fread(&data, sizeof(word), 1, rp)) {
		setMem(pos++, data);
	}
	fclose(rp);
	return pos - 0x10;
}

int loadSymbol(char *fname)
{
	char	filename[BUFSIZ];

	initLabel();
	makeSymName(fname, filename);
	return readLabel(filename);
}

void dispHelp()
{

}

void dispDebugCommand()
{
	printf(
		"メモリダンプ: D [開始アドレス] [ワード数=1]\n"
		"逆アセンブル: L [開始アドレス] [ワード数=8]\n"
		"ＢＰ設定:     B 設定アドレス [回数=1]\n"
		"ＢＰ解除:     C 設定アドレス\n"
		"ステップ実行: S ［実行回数=1］\n"
		"連続実行:     G [実行終了アドレス]\n"
		"レジスタ設定: R レジスタ番号 値\n"
		"\n"
	);
}
